---------------------
PatchSet 261 
Date: 2000/05/03 19:22:24
Author: hno
Branch: te
Tag: (none) 
Log:
Syncronized with devel

Members: 
	CONTRIBUTORS:1.1.1.3->1.1.1.3.8.1 
	ChangeLog:1.1.1.3.8.1->1.1.1.3.8.2 
	acconfig.h:1.1.1.3.8.2->1.1.1.3.8.3 
	configure.in:1.1.1.3.8.2->1.1.1.3.8.3 
	makefile.in:1.1.1.3.8.1->1.1.1.3.8.2 
	auth_modules/Makefile.in:1.1->1.1.12.1 
	auth_modules/dummy.in:1.1.1.1->1.1.1.1.12.1(DEAD) 
	auth_modules/MSNT/Makefile:1.1.1.1->1.1.1.1.8.1(DEAD) 
	auth_modules/MSNT/Makefile.in:1.1->1.1.10.1 
	auth_modules/SMB/Makefile.in:1.1.1.1->1.1.1.1.8.1 
	doc/Programming-Guide/Makefile:1.1.1.1->1.1.1.1.14.1 
	doc/Programming-Guide/prog-guide.sgml:1.1.1.2.8.1->1.1.1.2.8.2 
	icons/Makefile.in:1.1.1.3->1.1.1.3.8.1 
	src/HttpReply.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/Makefile.in:1.1.1.3.8.1->1.1.1.3.8.2 
	src/access_log.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/acl.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/aiops.c:1.1.1.3.8.1->1.1.1.3.8.2(DEAD) 
	src/async_io.c:1.1.1.3.4.1.4.1->1.1.1.3.4.1.4.2(DEAD) 
	src/cache_cf.c:1.1.1.3.4.1.4.1->1.1.1.3.4.1.4.2 
	src/cf.data.pre:1.1.1.3.4.1.4.1->1.1.1.3.4.1.4.2 
	src/cf_gen.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/cf_gen_defines:1.1->1.1.12.1 
	src/client_side.c:1.1.1.3.4.1.4.2->1.1.1.3.4.1.4.3 
	src/comm_select.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/defines.h:1.1.1.3.8.1->1.1.1.3.8.2 
	src/delay_pools.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/disk.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/diskd.c:1.1.6.1->1.1.6.2(DEAD) 
	src/dns_internal.c:1.1.1.1.4.1.4.2->1.1.1.1.4.1.4.3 
	src/enums.h:1.1.1.3.8.2->1.1.1.3.8.3 
	src/event.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/fd.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/filemap.c:1.1.1.2.8.1->1.1.1.2.8.2 
	src/forward.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/ftp.c:1.1.1.3.4.1.4.1->1.1.1.3.4.1.4.2 
	src/globals.h:1.1.1.3.8.1->1.1.1.3.8.2 
	src/helper.c:1.1.1.3->1.1.1.3.8.1 
	src/http.c:1.1.1.3.4.1.4.2->1.1.1.3.4.1.4.3 
	src/ipc.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/main.c:1.1.1.3.4.1.4.1->1.1.1.3.4.1.4.2 
	src/mem.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/neighbors.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/net_db.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/peer_select.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/protos.h:1.1.1.3.8.2->1.1.1.3.8.3 
	src/pump.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/snmp_agent.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/squid.h:1.1.1.3.8.1->1.1.1.3.8.2 
	src/ssl.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/stat.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/store.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/store_client.c:1.1.1.3.4.1.4.1->1.1.1.3.4.1.4.2 
	src/store_dir.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/store_dir_ufs.c:1.1.1.1.8.1->1.1.1.1.8.2(DEAD) 
	src/store_heap_replacement.c:1.1.1.1.8.1->1.1.1.1.8.2 
	src/store_io.c:1.1.1.1->1.1.1.1.8.1 
	src/store_io_asyncufs.c:1.1.1.1.4.1.4.1->1.1.1.1.4.1.4.2(DEAD) 
	src/store_io_ufs.c:1.1.1.1.8.1->1.1.1.1.8.2(DEAD) 
	src/store_log.c:1.1.1.2.8.1->1.1.1.2.8.2 
	src/store_modules.sh:1.1->1.1.12.1 
	src/store_rebuild.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/store_swapin.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/store_swapout.c:1.1.1.3.4.1.4.1->1.1.1.3.4.1.4.2 
	src/structs.h:1.1.1.3.4.1.4.2->1.1.1.3.4.1.4.3 
	src/tools.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/typedefs.h:1.1.1.3.8.1->1.1.1.3.8.2 
	src/unlinkd.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/url.c:1.1.1.3.8.1->1.1.1.3.8.2 
	src/fs/Makefile.in:1.1->1.1.12.1 
	src/fs/aufs/Makefile.in:1.1->1.1.12.1 
	src/fs/aufs/aiops.c:1.1->1.1.12.1 
	src/fs/aufs/async_io.c:1.1->1.1.12.1 
	src/fs/aufs/store_asyncufs.h:1.1->1.1.12.1 
	src/fs/aufs/store_dir_aufs.c:1.1->1.1.12.1 
	src/fs/aufs/store_io_aufs.c:1.1->1.1.12.1 
	src/fs/coss/Makefile.in:1.1->1.1.10.1 
	src/fs/coss/store_coss.h:1.1->1.1.10.1 
	src/fs/coss/store_dir_coss.c:1.1->1.1.10.1 
	src/fs/coss/store_io_coss.c:1.1->1.1.10.1 
	src/fs/diskd/Makefile.in:1.1->1.1.12.1 
	src/fs/diskd/diskd.c:1.1->1.1.12.1 
	src/fs/diskd/store_dir_diskd.c:1.1->1.1.12.1 
	src/fs/diskd/store_diskd.h:1.1->1.1.12.1 
	src/fs/diskd/store_io_diskd.c:1.1->1.1.12.1 
	src/fs/ufs/Makefile.in:1.1->1.1.12.1 
	src/fs/ufs/store_dir_ufs.c:1.1->1.1.12.1 
	src/fs/ufs/store_io_ufs.c:1.1->1.1.12.1 
	src/fs/ufs/store_ufs.h:1.1->1.1.12.1 

Index: squid/CONTRIBUTORS
===================================================================
RCS file: /cvsroot/squid-sf//squid/CONTRIBUTORS,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.8.1
diff -u -r1.1.1.3 -r1.1.1.3.8.1
--- squid/CONTRIBUTORS	26 Jan 2000 03:25:00 -0000	1.1.1.3
+++ squid/CONTRIBUTORS	3 May 2000 19:22:24 -0000	1.1.1.3.8.1
@@ -70,6 +70,7 @@
 	Niall Doherty <ndoherty@eei.ericsson.se>
 	Pedro Ribeiro <pribeiro@isel.pt>
 	John Dilley <jad@hpl.hp.com>
+	Adrian Chadd <adrian@creative.net.au>
 
 Development of this caching software is funded by the National Science
 Foundation (grants NCR-9616602 and NCR-9521745).  Paid staff members on
Index: squid/ChangeLog
===================================================================
RCS file: /cvsroot/squid-sf//squid/ChangeLog,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/ChangeLog	16 Apr 2000 23:59:14 -0000	1.1.1.3.8.1
+++ squid/ChangeLog	3 May 2000 19:22:24 -0000	1.1.1.3.8.2
@@ -1,8 +1,66 @@
+
 Changes to Squid-2.4.DEVEL3 ():
 
 	- Added Logfile module.
 	- Added DISKD stats via cachemgr.
 	- Added squid.conf options for DISKD magic constants.
+	- Added --enable-auth-modules=... configure option
+	- Improved ICP dead peer detection to also work when the workload
+	  is low
+	- Improved TCP dead peer detection and recovery
+	- Squid is now a bit more persistent in trying to find a alive
+	  parent when never_direct is used.
+	- nonhierarchical_direct squid.conf directive to make non-ICP
+	  peer selection behave a bit more like ICP selection with respect
+	  to hierarchy.
+	- Bugfix where netdb selection could override never_direct
+	- ICP timeout selection now prefers to use parents only when
+	  calculating the dynamic timeout to compensate for common RTT
+	  differences between parents and siblings.
+	- No longer starts to swap out objects which are known to be above
+	  the maximum allowed size.
+	- allow-miss cache_peer option disabling the use of "only-if-cached".
+	  Meant to be used in conjunction with icp_hit_stale.
+	- Delay pools tuned to allow large initial pool values
+	- cachemgr filesystem space information changed to show useable space
+	  rather than raw space, and platform support somewhat extended.
+	- Logs destination IP in the hierarchy log tag when going direct.
+	  (can be disabled by turning log_ip_on_direct off)
+	- Async-IO on linux now makes proper use of mutexes. This fixes some
+	  odd pthread segfaults on SMP Linux machines, at a slight performance
+	  penalty.
+	- %s can now be used in cache_swap_log and will be substituded with
+	  the last path component of cache_dir.
+	- no_cache is now a full ACL check without, allowing most ACL types
+	  to be used.
+	- The CONNECT method now obeys miss_access requirements
+	- proxy_auth_regex and ident_regex ACL types
+	- Fixed a StoreEntry memory leak during "dirty" rebuild
+	- Helper processes no longer hold unrelated filedescriptors open
+	- Helpers are now restarted when the logs are rotated
+	- Negatively cached DNS entries are now purged on "reload".
+	- PURGE now also purges the DNS cache
+	- HEAD on FTP objects no longer retreives the whole object
+	- More cleanups of the dstdomain ACL type
+	- Squid no longer tries to do Range internally if it is not supported
+	  by the origin server. Doing so could cause bandwidth spikes and/or
+	  negative hit ratio.
+	- httpd_accel_single_host squid.conf directive
+	- "round-robin" cache_peer counters are reset every 5 minutes to
+	  compensate previously dead peers
+	- DNS retransmit parameters
+	- Show all FTP server messages
+	- squid.conf.default now indicates if a directive isn't enabled in
+	  the installed binary, and what configure option to use for enabling it
+	- Fixed a temporary memory leak on persistent POSTs
+	- Fixed a temporary memory leak when the server response headers
+	  includes NULL characters
+	- authenticate_ip_ttl_is_strict squid.conf option
+	- req_mime_type ACL type
+	- A reworked storage system that supports storage directories in
+	  a more modular fashion. The object replacement and IO is now
+	  responsibility of the storage directory, and not of the storage
+	  manager.
 
 Changes to Squid-2.4.DEVEL2 ():
 
Index: squid/acconfig.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/Attic/acconfig.h,v
retrieving revision 1.1.1.3.8.2
retrieving revision 1.1.1.3.8.3
diff -u -r1.1.1.3.8.2 -r1.1.1.3.8.3
--- squid/acconfig.h	16 Apr 2000 23:59:14 -0000	1.1.1.3.8.2
+++ squid/acconfig.h	3 May 2000 19:22:24 -0000	1.1.1.3.8.3
@@ -20,7 +20,7 @@
  *
  */
 @ TOP @
-/* $Id: acconfig.h,v 1.1.1.3.8.2 2000/04/16 23:59:14 hno Exp $ */
+/* $Id: acconfig.h,v 1.1.1.3.8.3 2000/05/03 19:22:24 hno Exp $ */
 
 /*********************************
  * START OF CONFIGURABLE OPTIONS *
@@ -49,7 +49,7 @@
 #undef USE_ASYNC_IO
 
 /* Defines how many threads to use for async I/O */
-#undef NUMTHREADS
+#undef ASYNC_IO_THREADS
 
 /*
  * If you want to use Squid's ICMP features (highly recommended!) then
@@ -276,3 +276,6 @@
  * message type for message queues
  */
 #undef mtyp_t
+
+/* Define if you want to set the COSS membuf size */
+#undef COSS_MEMBUF_SZ
Index: squid/configure.in
===================================================================
RCS file: /cvsroot/squid-sf//squid/configure.in,v
retrieving revision 1.1.1.3.8.2
retrieving revision 1.1.1.3.8.3
diff -u -r1.1.1.3.8.2 -r1.1.1.3.8.3
--- squid/configure.in	16 Apr 2000 23:59:15 -0000	1.1.1.3.8.2
+++ squid/configure.in	3 May 2000 19:22:24 -0000	1.1.1.3.8.3
@@ -3,13 +3,13 @@
 dnl
 dnl  Duane Wessels, wessels@nlanr.net, February 1996 (autoconf v2.9)
 dnl
-dnl  $Id: configure.in,v 1.1.1.3.8.2 2000/04/16 23:59:15 hno Exp $
+dnl  $Id: configure.in,v 1.1.1.3.8.3 2000/05/03 19:22:24 hno Exp $
 dnl
 dnl
 dnl
 AC_INIT(src/main.c)
 AC_CONFIG_HEADER(include/autoconf.h)
-AC_REVISION($Revision: 1.1.1.3.8.2 $)dnl
+AC_REVISION($Revision: 1.1.1.3.8.3 $)dnl
 AC_PREFIX_DEFAULT(/usr/local/squid)
 AC_CONFIG_AUX_DIR(cfgaux)
 
@@ -236,46 +236,90 @@
   fi
 ])
 
-AC_ARG_ENABLE(async_io,
+AC_ARG_ENABLE(async-io,
 [  --enable-async-io[=N_THREADS]
-                          Do ASYNC disk I/O using threads.
-                          N_THREADS is the number of worker threads
-                          defaults to 16. See also src/squid.h for
-                          some additional platform tuning],
-[ case "$enableval" in
+                          Shorthand for
+                          --with-aio-threads=N_THREADS
+                          --with-pthreads
+                          --enable-storeio=ufs,aufs],
+[ case $enableval in
   yes)
-    async_io=yes
+  	with_pthreads=yes
+	STORE_MODULES="ufs aufs"
     ;;
   no)
-    async_io=''
     ;;
   *)
-    async_io=yes
-    AC_DEFINE_UNQUOTED(NUMTHREADS, $enableval)
+  	async_io_threads=$enableval
+	with_pthreads=yes
+	STORE_MODULES="ufs aufs"
     ;;
   esac
 ])
 
-if test -n "$async_io" ; then
-    echo "Async I/O enabled"
-    async_io=yes
-    AC_DEFINE(USE_ASYNC_IO)
-    ASYNC_OBJS='$(ASYNC_OBJS)'
+AC_ARG_WITH(aio-threads,
+[  --with-aio-threads=N_THREADS
+                          Tune the number of worker threads for the aufs object
+                          store.],
+[ async_io_threads=$withval ])
+if test "$async_io_threads"; then
+    echo "With $async_io_threads AIO threads"
+    with_pthreads=yes
+    AC_DEFINE_UNQUOTED(ASYNC_IO_THREADS,$async_io_threads)
+fi
+
+AC_ARG_WITH(pthreads,
+[  --with-pthreads         Use POSIX Threads],
+[ if test "$enableval" = "yes"; then
+    with_pthreads=yes
+  fi
+])
+if test "$with_pthreads"; then
+    echo "With pthreads"
     SQUID_PTHREAD_LIB='$(PTHREADLIB)'
     CFLAGS="$CFLAGS -D_REENTRANT"
     case "$host" in
     i386-unknown-freebsd*)
-    	if test "$GCC" = "yes" ; then
-	    if test -z "$PRESET_LDFLAGS"; then
-		LDFLAGS="$LDFLAGS -pthread"
-	    fi
-	fi
-	;;
+        if test "$GCC" = "yes" ; then
+            if test -z "$PRESET_LDFLAGS"; then
+                LDFLAGS="$LDFLAGS -pthread"
+            fi
+        fi
+    ;;
     esac
 fi
-AC_SUBST(ASYNC_OBJS)
 AC_SUBST(SQUID_PTHREAD_LIB)
 
+AC_ARG_ENABLE(storeio,
+[  --enable-storeio=\"list of modules\"
+                          Build support for the list of store I/O modules.
+                          The default is only to build the "ufs" module.
+                          See src/fs for a list of available modules, or
+                          Programmers Guide section <not yet written>
+                          for details on how to build your custom store module],
+[ case $enableval in
+  yes)
+	for module in $srcdir/src/fs/*; do
+	    if test -f $module/Makefile.in; then
+		STORE_MODULES="$STORE_MODULES `basename $module`"
+	    fi
+	done
+  	;;
+  no)
+  	;;
+  *)	STORE_MODULES="`echo $enableval| sed -e 's/,/ /g;s/  */ /g'`"
+	;;
+  esac
+],
+[ if test -z "$STORE_MODULES"; then
+    STORE_MODULES="ufs"
+  fi
+])
+echo "Store moules built: $STORE_MODULES"
+AC_SUBST(STORE_MODULES)
+STORE_OBJS="fs/`echo $STORE_MODULES|sed -e's% %.a fs/%g'`.a"
+AC_SUBST(STORE_OBJS)
+
 AC_ARG_ENABLE(icmp,
 [  --enable-icmp           Enable ICMP pinging],
 [ if test "$enableval" = "yes" ; then
@@ -428,6 +472,15 @@
 ],[ERR_LANGUAGE="English"])
 AC_SUBST(ERR_LANGUAGE)
 
+dnl Size of COSS memory buffer
+AC_ARG_WITH(coss-membuf-size,
+[  --with-coss-membuf-size COSS membuf size (default 1048576 bytes) ],
+[  if test "$with_coss_membuf_size"; then
+      echo "Setting COSS membuf size to $with_coss_membuf_size bytes"
+      AC_DEFINE_UNQUOTED(COSS_MEMBUF_SZ, $with_coss_membuf_size)
+   fi
+])
+
 dnl Enable poll()
 AC_ARG_ENABLE(poll,
 [  --enable-poll           Enable poll() instead of select().  Normally poll
@@ -546,8 +599,7 @@
 [  --enable-heap-replacement
                           This option allows you to use various cache
                           replacement algorithms, instead of the standard
-                          LRU algorithm.
-                          ],
+                          LRU algorithm.],
 [ if test "$enableval" = "yes" ; then
     echo "Enabling HEAP_REPLACEMENT"
     AC_DEFINE(HEAP_REPLACEMENT, 1)
@@ -567,19 +619,32 @@
   fi
 ])
 
-dnl Enable "diskd" code
-AC_ARG_ENABLE(diskd,
-[  --enable-diskd          Uses shared memory, message queues, and external
-                          processes for disk I/O.],
-[ if test "$enableval" = "yes" ; then
-    echo "DISKD enabled"
-    AC_DEFINE(USE_DISKD, 1)
-    OPT_DISKD_EXE='$(DISKD_EXE)'
-    AC_SUBST(OPT_DISKD_EXE)
-    DISKD_OBJS='diskd.o'
-    AC_SUBST(DISKD_OBJS)
-  fi
+dnl Select auth modules to build
+AUTH_MODULES=
+AC_ARG_ENABLE(auth-modules,
+[  --enable-auth-modules=\"list of modules\"
+                          This option selects wich proxy_auth helper modules
+                          to build and install as part of the normal build
+                          process. For a list of available modules see
+                          the auth_modules directory.],
+[ case "$enableval" in
+  yes) 
+    for module in $srcdir/auth_modules/*; do
+	if test -f $module/Makefile.in; then
+	    AUTH_MODULES="$AUTH_MODULES `basename $module`"
+	fi
+    done
+    ;;
+  no)
+    ;;
+  *)
+    AUTH_MODULES="`echo $enableval| sed -e 's/,/ /g;s/  */ /g'`"
+  esac
 ])
+if test -n "$AUTH_MODULES"; then
+    echo "Auth moules built: $AUTH_MODULES"
+fi
+AC_SUBST(AUTH_MODULES)
 
 # Force some compilers to use ANSI features
 #
@@ -680,6 +745,7 @@
 	strings.h \
 	sys/file.h \
 	sys/ioctl.h \
+	sys/mount.h \
 	sys/msg.h \
 	sys/param.h \
 	sys/resource.h \
@@ -687,6 +753,7 @@
 	sys/socket.h \
 	sys/stat.h \
 	sys/statvfs.h \
+	sys/vfs.h \
 	sys/syscall.h \
 	sys/time.h \
 	sys/types.h \
@@ -1006,6 +1073,9 @@
 	mktime \
 	mstats \
 	poll \
+	pthread_attr_setscope \
+	pthread_setschedparam \
+	pthread_attr_setschedparam \
 	putenv \
 	random \
 	regcomp \
@@ -1023,20 +1093,13 @@
 	snprintf \
 	srand48 \
 	srandom \
+	statfs \
 	sysconf \
 	syslog \
 	timegm \
 	vsnprintf \
 )
 
-if test "$async_io" = "yes" ; then
-	AC_CHECK_FUNCS(\
-		pthread_attr_setscope \
-		pthread_setschedparam \
-		pthread_attr_setschedparam \
-	)
-fi
-
 dnl Yay!  Another Linux brokenness.  Its not good enough
 dnl to know that setresuid() exists, because RedHat 5.0 declares
 dnl setresuid() but doesn't implement it.
@@ -1489,14 +1552,20 @@
 	./scripts/RunCache \
 	./scripts/RunAccel \
 	./src/Makefile \
+	./src/fs/Makefile \
+	./src/fs/ufs/Makefile \
+	./src/fs/aufs/Makefile \
+	./src/fs/coss/Makefile \
+	./src/fs/diskd/Makefile \
 	./contrib/Makefile \
 	$SNMP_MAKEFILE \
 	./icons/Makefile \
 	./errors/Makefile \
-	./auth_modules/dummy \
+	./auth_modules/Makefile \
 	./auth_modules/NCSA/Makefile \
 	./auth_modules/PAM/Makefile \
-	./auth_modules/SMB/Makefile
+	./auth_modules/SMB/Makefile \
+	./auth_modules/MSNT/Makefile \
 	./auth_modules/getpwnam/Makefile \
 	./auth_modules/LDAP/Makefile \
 )
Index: squid/doc/Programming-Guide/Makefile
===================================================================
RCS file: /cvsroot/squid-sf//squid/doc/Programming-Guide/Makefile,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.14.1
diff -u -r1.1.1.1 -r1.1.1.1.14.1
--- squid/doc/Programming-Guide/Makefile	26 Jan 2000 03:23:10 -0000	1.1.1.1
+++ squid/doc/Programming-Guide/Makefile	3 May 2000 19:22:25 -0000	1.1.1.1.14.1
@@ -3,7 +3,7 @@
 all: $(DOC).html $(DOC).ps
 
 $(DOC).ps: $(DOC).dvi
-	dvips $(DOC).dvi
+	dvips -o $(DOC).ps $(DOC).dvi
 
 $(DOC).dvi: $(DOC).sgml
 	sgml2latex $(DOC)
